#!/usr/bin/env python

import org.maemo.hermes.engine.facebook.provider
import gnome.gconf
import org.maemo.hermes.engine.twitter.provider
import org.maemo.hermes.engine.gravatar.provider
import org.maemo.hermes.engine.linkedin.provider
from org.maemo.hermes.gui.gtkui import HermesGUI

# -- Check environment...
#
if gnome.gconf.client_get_default().get_string('/desktop/gnome/url-handlers/http/command') == 'epiphany %s':
    raise Exception('Browser in gconf invalid (see NB#136012). Installation error.')

# -- Start the GUI with the known providers...
#
gui = HermesGUI(providers = [
                 org.maemo.hermes.engine.facebook.provider.Provider(),
                 org.maemo.hermes.engine.linkedin.provider.Provider(),
                 org.maemo.hermes.engine.twitter.provider.Provider(),
                 org.maemo.hermes.engine.gravatar.provider.Provider(),
             ])
gui.run()

